namespace boost {
    template< class P > class shared_ptr { public: P *data; }
};

namespace std {
    template< class K, class D > class map { public: K key; D data; };
};

class Internal
{
public:
    int data;
};

typedef boost::shared_ptr< Internal >  InternalPtr;

// This typedef does not work
typedef std::map< int, InternalPtr > InternalMap;

// This typedef will work
//typedef std::map< int, boost::shared_ptr< Internal > > InternalMap;

class ExternalMap
{
public:
    // Collaboration diagram will not show we use the Internal class unless the
    // commented-out InternalMap typedef if used.

    InternalMap a_map;
};
